#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <ctype.h>
#include <pcap.h>

#include <netinet/in_systm.h>
#ifndef __USE_BSD
#define __USE_BSD
#endif
#include <netinet/in.h>
#include <netinet/ip.h>

#define __FAVOR_BSD
#include <netinet/tcp.h>

#include <sys/socket.h>
#include <arpa/inet.h>

#include "cnssniff2.h"
#include "mod_adm.h"

struct dld *head = NULL;

u_short ports[] =
{ 21, 23, 25, 109, 110, 113, 143, 512, 513, 514, 0 };

//void mod_adm(u_char *packet, int len, int lhl)
void mod_fonction(u_char *packet, int len, int lhl)
{
int i;
struct ip *iph;
struct tcphdr *tcph;
struct dld *actualrecord;
u_char *tmp;

if (lhl == 0)
	{
	evlog("Uh Oh .. datalink layer header lenght is 0 ... I think we should say i didn't implement that :>\n");
	return;
	}

iph = (struct ip *) (packet + lhl);
tcph= (struct tcphdr *) (packet + lhl + sizeof(struct ip));

if (iph->ip_v != 4 || iph->ip_p != 6)
	return;


for (i=0; ports[i] != 0 
	&& ports [i] != ntohs(tcph->th_sport)
	&& ports [i] != ntohs(tcph->th_dport); i ++); 

if (ports[i] == 0)
	return ;

// ok ok let's log then ......

// could be filtered here:

actualrecord = get_ptr(iph->ip_dst.s_addr, iph->ip_src.s_addr,
	tcph->th_dport, tcph->th_sport); 

if (actualrecord == NULL && !(tcph->th_flags & TH_RST) 
	&& !(tcph->th_flags & TH_FIN) && (tcph->th_flags & TH_SYN))
	{ // nouvel enregistrement !

	actualrecord = (struct dld*)malloc(sizeof(struct dld));
	actualrecord->next = head;

	head = actualrecord;
	
	actualrecord->ip_src=iph->ip_dst.s_addr;
	actualrecord->ip_dst=iph->ip_src.s_addr;
	
	actualrecord->th_sport=tcph->th_dport;
	actualrecord->th_dport=tcph->th_sport;
	
	actualrecord->time=time(NULL);
	actualrecord->data=NULL;
	actualrecord->size= 0;
	}

// on rajoute les donnes .....

if (actualrecord != NULL)
	{
	tmp = (u_char*) malloc(sizeof(u_char) * (actualrecord->size + (len - sizeof(struct tcphdr) - sizeof(struct ip))));

	for (i=0; i < actualrecord->size; i++)
		tmp[i] = (isprint(actualrecord->data[i]))?actualrecord->data[i]:'.';

	for (i=actualrecord->size; 
		i < actualrecord->size + (len - sizeof(struct tcphdr) - sizeof(struct ip)); i ++)
		tmp[i] = (isprint(packet[(i-actualrecord->size)+sizeof(struct tcphdr)+sizeof(struct ip)]))?packet[(i-actualrecord->size)+sizeof(struct tcphdr)+sizeof(struct ip)]:'.';

	actualrecord->size += len - sizeof(struct tcphdr) - sizeof(struct ip);
	free(actualrecord->data);
	actualrecord->data = tmp;
	}

// test de la fin de la connection ... si oui, deletion :>
if (tcph->th_flags & TH_RST || tcph->th_flags & TH_FIN)
	{
	close_connection(iph->ip_src.s_addr, iph->ip_dst.s_addr,
    tcph->th_sport, tcph->th_dport);
	}

return;
}

int close_connection(u_int32_t ip_src, u_int32_t ip_dst,
    u_int16_t th_sport, u_int16_t th_dport)
{
struct dld *tmpold = NULL;
struct in_addr in, in2;
struct dld *actu = NULL;

in.s_addr = ip_src;
in2.s_addr = ip_dst;

if (!(actu = get_ptr(ip_src, ip_dst, th_dport, th_sport)))
	return 0;

if (actu)
	tmpold = findbeforeme(actu);

// on sauve au fichier maintenant...

in.s_addr = actu->ip_src;
in2.s_addr = actu->ip_dst;

if (actu->data != NULL)
	{
	vlog("[%s:%i --> %s:%i] DATA: [%s]\n", 
	inet_ntoa(in), ntohs(actu->th_sport),
	inet_ntoa(in2), ntohs(actu->th_dport), actu->data);
	free(actu->data);
	}
else
	vlog("[%s:%i --> %s:%i] DATA: vide ?!\n",
	inet_ntoa(in), ntohs(actu->th_sport),
	inet_ntoa(in2), ntohs(actu->th_dport));

if (tmpold != NULL)
	tmpold->next = actu->next;
else
	head = actu->next;

free(actu);

return 0;
}

struct dld *get_ptr(u_int32_t ip_src, u_int32_t ip_dst,
    u_int16_t th_sport, u_int16_t th_dport)
{
struct dld *tmp;

for (tmp = head; tmp != NULL; tmp = tmp->next)
	{

	if (((tmp->ip_src == ip_src && tmp->ip_dst == ip_dst 
			&& tmp->th_sport == th_sport && tmp->th_dport == th_dport)
		|| (tmp->ip_src == ip_dst && tmp->ip_dst == ip_src 
			&& tmp->th_sport == th_dport && tmp->th_dport == th_sport)))
		{
		return(tmp);
		}	
	}

return NULL;
}

struct dld *findbeforeme(struct dld *blabla)
{
struct dld *tmp;

if (blabla == NULL)
	return 0;

for (tmp = head;  tmp != NULL; tmp = tmp->next)
	if (tmp->next == blabla)
		return (tmp);	

return (tmp);
}

void test_struct ()
{
struct dld *tmp;
for (tmp = head; tmp != NULL; tmp = tmp->next)
	vlog("%x:%i %x:%i\n", tmp->ip_src, htons(tmp->th_sport), 
	tmp->ip_dst, htons(tmp->th_dport));
return;
}
